## qt6-qml-pdwidgets1 1.0.1.g9354cb2

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
# Copyright (C) 2022 Bjarne von Horn <vh@igh.de>
#
# This file is part of the Qt6QmlPdWidgets library.
#
# The Qt6QmlPdWidgets library is free software: you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the License,
# or (at your option) any later version.
#
# The Qt6QmlPdWidgets library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with the Qt6QmlPdWidgets Library. If not, see
# <http://www.gnu.org/licenses/>.
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.19)

project(Qt6QmlPdWidgets1 VERSION 1.0.1)

set(LIBNAME Qt6QmlPdWidgets1)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(BUILD_EXAMPLE "Build and install example" OFF)
option(GENERATE_QHP "Build Qt Assistant help files" OFF)

set(PUBLIC_QT_COMPONENTS Core Quick)

set(PRIVATE_QT_COMPONENTS Qml Xml Svg)
if (GENERATE_QHP)
    list(APPEND PRIVATE_QT_COMPONENTS Tools)
endif()

find_package(Qt6 6.3 REQUIRED
    COMPONENTS ${PUBLIC_QT_COMPONENTS} ${PRIVATE_QT_COMPONENTS} LinguistTools
)
find_package(Qt6PdCom1 1.4 REQUIRED COMPONENTS Qml)
qt_standard_project_setup()

if (NOT PD_QML_INSTALL_PATH)
    if (NOT QT6_INSTALL_QML)
        set(PD_QML_INSTALL_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/qt6/qml")
    else()
        set(PD_QML_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${QT6_INSTALL_QML}")
    endif()
endif()

message(STATUS "Installing Qml Widgets to ${PD_QML_INSTALL_PATH}")

configure_file(Qt6QmlPdWidgets1.h.in "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/Qt6QmlPdWidgets1.h")

set(ALL_SOURCES
    src/QtPdCom_classes.h
    src/LiveSvg.cpp
    src/LiveSvg.h
    src/LiveSvg_p.h
    src/Qt6QmlPdWidgets.cpp
)

if (BUILD_SHARED_LIBS)
    qt6_add_library(${LIBNAME} SHARED ${ALL_SOURCES})
    qt6_add_library(${LIBNAME}_style SHARED)
else()
    qt6_add_library(${LIBNAME} STATIC ${ALL_SOURCES})
    qt6_add_library(${LIBNAME}_style STATIC)
endif()

set(QML_FILE_NAMES
    PdTouchEdit.qml
    Sprintf.js
    PdCheckBox.qml
    PdSlider.qml
    PdTimeLabel.qml
    PdSwitch.qml
    Pd.qml
    PdLed.qml
    PdText.qml
    PdToolButton.qml
    PdMultiLed.qml
    TouchEditDialog.qml
    PdComboBox.qml
    PdPushButton.qml
    PdBar.qml
    PdImage.qml
    PdLabel.qml
    PdDigital.qml
    LoginDialog.qml
    TouchEdit.qml
    PdTumbler.qml
)

set(QML_SOURCE_PREFIX "qml/de/igh/pd")

set(QML_FILES "")
foreach(QML_FILE ${QML_FILE_NAMES})
    set_source_files_properties("${QML_SOURCE_PREFIX}/${QML_FILE}" PROPERTIES
        QT_RESOURCE_ALIAS "${QML_FILE}"
    )
    list(APPEND QML_FILES "${QML_SOURCE_PREFIX}/${QML_FILE}")
endforeach()

set(ADDITIONAL_RESOURCE_NAMES
    FontAwesome.otf
)

set(PDQML_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/qml_out/de/igh/pd")

set(ADDITIONAL_RESOURCES "")
foreach(RESOURCE_FILE ${ADDITIONAL_RESOURCE_NAMES})
    set_source_files_properties("${QML_SOURCE_PREFIX}/${RESOURCE_FILE}" PROPERTIES
        QT_RESOURCE_ALIAS "${RESOURCE_FILE}"
        QT_QML_SOURCE_VERSIONS "${PROJECT_VERSION_MAJOR}.0"
    )
    list(APPEND ADDITIONAL_RESOURCES "${QML_SOURCE_PREFIX}/${RESOURCE_FILE}")
    configure_file("${QML_SOURCE_PREFIX}/${RESOURCE_FILE}" "${PDQML_OUTPUT_DIR}/${RESOURCE_FILE}" COPYONLY)
endforeach()

set_source_files_properties("${QML_SOURCE_PREFIX}/Pd.qml" PROPERTIES
    QT_QML_SINGLETON_TYPE TRUE
)

qt_add_qml_module(${LIBNAME}
    URI de.igh.pd
    VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
    IMPORTS de.igh.qtpdcom/1.4
    NO_PLUGIN_OPTIONAL
    QML_FILES
        ${QML_FILES}
    RESOURCES
        ${ADDITIONAL_RESOURCES}
    RESOURCE_PREFIX "/de.igh.pd${PROJECT_VERSION_MAJOR}/imports"
    OUTPUT_DIRECTORY "${PDQML_OUTPUT_DIR}"
    IMPORT_PATH "${CMAKE_CURRENT_BINARY_DIR}/qml_out;${QTPDCOM_QML_ROOT_PATH}"
    OUTPUT_TARGETS PD_QML_PLUGIN_TARGETS
)

set_source_files_properties("${QML_SOURCE_PREFIX}/style/Solarized.qml" PROPERTIES
    QT_RESOURCE_ALIAS "Solarized.qml"
    QT_QML_SINGLETON_TYPE TRUE
)

qt_add_qml_module(${LIBNAME}_style
    URI de.igh.pd.style
    VERSION 1.0
    QML_FILES
        "${QML_SOURCE_PREFIX}/style/Solarized.qml"
    RESOURCE_PREFIX "/de.igh.pd${PROJECT_VERSION_MAJOR}/imports"
    OUTPUT_DIRECTORY "${PDQML_OUTPUT_DIR}/style"
    IMPORT_PATH "${CMAKE_CURRENT_BINARY_DIR}/qml_out"
    OUTPUT_TARGETS PD_STYLE_QML_PLUGIN_TARGETS
)

if ("${Qt6_VERSION}" VERSION_GREATER_EQUAL "6.7")
    qt_add_translations(${LIBNAME}
        TS_FILES Qt6QmlPdWidgets_de.ts
        RESOURCE_PREFIX "/de.igh.pd${PROJECT_VERSION_MAJOR}/i18n"
        IMMEDIATE_CALL
        OUTPUT_TARGETS PD_TRANSLATION_TARGETS
    )
else()
    qt_add_translations(${LIBNAME}
        TS_FILES Qt6QmlPdWidgets_de.ts
        RESOURCE_PREFIX "/de.igh.pd${PROJECT_VERSION_MAJOR}/i18n"
        OUTPUT_TARGETS PD_TRANSLATION_TARGETS
    )
endif()

target_include_directories(${LIBNAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
    "$<INSTALL_INTERFACE:include>"
)


target_include_directories(${LIBNAME} PRIVATE
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>/src"
)

target_link_libraries(${LIBNAME}
    PUBLIC
        Qt6::Core
        Qt6::Quick
    PRIVATE
        EtherLab::Qt6PdCom1
        Qt6::Qml
        Qt6::Svg
        Qt6::Xml
)

set(SOVERSION 1)

set_target_properties(${LIBNAME} PROPERTIES
    VISIBILITY_INLINES_HIDDEN 1
    CXX_VISIBILITY_PRESET "hidden"
    VERSION "${SOVERSION}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
    SOVERSION ${SOVERSION}
)
set_target_properties(${LIBNAME}_style PROPERTIES
    VISIBILITY_INLINES_HIDDEN 1
    CXX_VISIBILITY_PRESET "hidden"
    VERSION "${SOVERSION}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
    SOVERSION ${SOVERSION}
)

set(TARGETS_TO_INSTALL
    ${PD_STYLE_QML_PLUGIN_TARGETS}
    ${PD_QML_PLUGIN_TARGETS}
    ${PD_TRANSLATION_TARGETS}
    ${LIBNAME}
    ${LIBNAME}plugin
    ${LIBNAME}_style
    ${LIBNAME}_styleplugin
    ${LIBNAME}_qmldir
)

# add fake interface library to export QML install dir
# for both build and install directory
add_library(${LIBNAME}_qmldir INTERFACE)
set_target_properties(${LIBNAME}_qmldir PROPERTIES
    INTERFACE_INCLUDE_DIRECTORIES "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/qml_out>$<INSTALL_INTERFACE:${PD_QML_INSTALL_PATH}>"
)

# and install it
foreach(TARGET ${TARGETS_TO_INSTALL})
    install(TARGETS ${TARGET}
        EXPORT ${TARGET}Targets
        ARCHIVE DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
        LIBRARY DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
        RUNTIME DESTINATION       "${CMAKE_INSTALL_BINDIR}"
        OBJECTS DESTINATION       "${CMAKE_INSTALL_LIBDIR}/${LIBNAME}"
    )

    install(EXPORT ${TARGET}Targets
        NAMESPACE EtherLab::
        FILE ${TARGET}Targets.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${LIBNAME}
    )

    export(EXPORT ${TARGET}Targets
        FILE "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${TARGET}Targets.cmake"
        NAMESPACE EtherLab::
    )
endforeach()

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/Qt6QmlPdWidgets1.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}"
)

install(DIRECTORY "${PDQML_OUTPUT_DIR}"
    DESTINATION "${PD_QML_INSTALL_PATH}/de/igh"
    FILES_MATCHING
        PATTERN "qmldir"
        PATTERN "*.otf"
        PATTERN "*.qml"
        PATTERN "*.js"
        PATTERN "*.qmltypes"
)

install(TARGETS ${LIBNAME}_styleplugin
    ARCHIVE DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION       "${PD_QML_INSTALL_PATH}/de/igh/pd/style"
    RUNTIME DESTINATION       "${PD_QML_INSTALL_PATH}/de/igh/pd/style"
)

install(TARGETS ${LIBNAME}plugin
    ARCHIVE DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION       "${PD_QML_INSTALL_PATH}/de/igh/pd"
    RUNTIME DESTINATION       "${PD_QML_INSTALL_PATH}/de/igh/pd"
)


# and export it

set(ConfigPackageLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${LIBNAME}")
configure_package_config_file(Config.cmake.in
        "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}Config.cmake"
    INSTALL_DESTINATION ${ConfigPackageLocation}
)
write_basic_package_version_file(
        "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}ConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}Config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}ConfigVersion.cmake"
    DESTINATION ${ConfigPackageLocation}
)

## bake in git commit hash


if (VERSION_HASH)
    # Hash was given as option, so write it directly
    # useful for OBS packaging
    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
        "#define GIT_REV \"${VERSION_HASH}\"
")
else()
    # recompute hash on every `make` invocation
    # Note: CMake variable definitions (-D) must be before the -P option!
    add_custom_target(GitRevision
        BYPRODUCTS "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
        COMMAND ${CMAKE_COMMAND}
            -DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}"
            -DHASH_MACRO_NAME="GIT_REV"
            -DTARGET_FILE="${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
            -P ${CMAKE_CURRENT_SOURCE_DIR}/git_revision.cmake
    )
    add_dependencies(${LIBNAME} GitRevision)
endif()


## Build example (optionally)

if (BUILD_EXAMPLE)
    add_library(EtherLab::${LIBNAME} ALIAS ${LIBNAME})
    add_library(EtherLab::${LIBNAME}_qmldir ALIAS ${LIBNAME}_qmldir)
    add_library(EtherLab::${LIBNAME}plugin ALIAS ${LIBNAME}plugin)
    add_library(EtherLab::${LIBNAME}_style ALIAS ${LIBNAME}_style)
    add_library(EtherLab::${LIBNAME}_styleplugin ALIAS ${LIBNAME}_styleplugin)
    set(PD_QML_ROOT_PATH "${CMAKE_CURRENT_BINARY_DIR}/qml_out")
    add_subdirectory(qml_test)
endif()

if (GENERATE_QHP)
    set(DOXYGEN_GENERATE_QHP "YES")
    get_target_property(DOXYGEN_QHG_LOCATION Qt6::qhelpgenerator IMPORTED_LOCATION)
else()
    set(DOXYGEN_GENERATE_QHP "NO")
endif()

configure_file(Doxyfile.in "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile" @ONLY)

=== qml_test/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
# Copyright (C) 2022 Bjarne von Horn <vh@igh.de>
#
# This file is part of the Qt6QmlPdWidgets library.
#
# The Qt6QmlPdWidgets library is free software: you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the License,
# or (at your option) any later version.
#
# The Qt6QmlPdWidgets library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with the Qt6QmlPdWidgets Library. If not, see
# <http://www.gnu.org/licenses/>.
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.19)

project(Qml6Test)
include(GNUInstallDirs)
option(USE_STATIC_QMLWIDGETS "Link in Qt6QmlPdWidgets statically" OFF)

# load Qt
find_package(Qt6 REQUIRED
    COMPONENTS Charts Gui Quick QuickControls2
)

qt_standard_project_setup()

# compile qml files (of this project) if compiler available

set(SOURCES
    src/ScalarSeries.h
    src/ScalarSeries.cpp
    src/main.cpp
)

find_package(Qt6PdCom1 1.4 REQUIRED COMPONENTS Qml)
if (NOT TARGET EtherLab::Qt6QmlPdWidgets1)
    find_package(Qt6QmlPdWidgets1 REQUIRED)
endif()

get_target_property(qtpdcom_target_type EtherLab::Qt6PdCom1 TYPE)

# fetch Path where pd qml widgets were installed/built
if (NOT EXTRA_QML_IMPORT_PATH)
    set(EXTRA_QML_IMPORT_PATH ${PD_QML_ROOT_PATH})
endif()

message(STATUS "QML import path: ${EXTRA_QML_IMPORT_PATH}")

qt_add_executable(${PROJECT_NAME} ${SOURCES})

qt_add_qml_module(${PROJECT_NAME}
    URI QmlTest
    VERSION 1.0
    IMPORTS
        de.igh.pd
        de.igh.pd.style
        QtCharts
    IMPORT_PATH "${QTPDCOM_QML_ROOT_PATH};${EXTRA_QML_IMPORT_PATH};${CMAKE_CURRENT_BINARY_DIR}/qml_out"
    RESOURCE_PREFIX "/"
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qml_out/QmlTest"
    NO_RESOURCE_TARGET_PATH
    QML_FILES
        qml/ChartsPane.qml
        qml/ChannelPane.qml
        qml/ConnectionDialog.qml
        qml/main.qml
        qml/MessageTableView.qml
        qml/MessagesPane.qml
        qml/ParameterPane.qml
        qml/SvgPane.qml
    RESOURCES
        images/book-solid.svg
        images/usb.svg
        images/cog.svg
        images/switch-off.svg
        images/sign-out.svg
        images/canbus.svg
        images/arrow-left.svg
        images/chart-area.svg
        images/trash-alt.svg
        images/plug.svg
        images/sync-alt.svg
        images/bolt.svg
        images/user-check.svg
        images/cogs.svg
        images/sign-in.svg
        images/arrow-down.svg
        images/wrench.svg
        images/ambulance.svg
        images/folder-open.svg
        images/save.svg
        images/arrow-up.svg
        images/svg_example.svg
        images/power-off.svg
        images/play-circle.svg
        images/arrow-right.svg
        images/user-lock.svg
        images/edit.svg
)

# WIN32_EXECUTABLE controls whether the CMD window is hidden
set_target_properties(${PROJECT_NAME} PROPERTIES
    AUTOUIC 0
    AUTOMOC 1
    AUTORCC 1
    WIN32_EXECUTABLE true
)

# link in Qt, the PdWidgets and the PdWidgets QML files

target_link_libraries(${PROJECT_NAME} PUBLIC
    EtherLab::Qt6PdCom1
    Qt6::Charts
    Qt6::Quick
    Qt6::QuickControls2
)

if (USE_STATIC_QMLWIDGETS)
    target_link_libraries(${PROJECT_NAME} PRIVATE
        EtherLab::Qt6QmlPdWidgets1plugin
        EtherLab::Qt6QmlPdWidgets1_styleplugin
    )
    target_compile_definitions(${PROJECT_NAME} PRIVATE STATIC_QMLWIDGETS)
endif()
if (qtpdcom_target_type STREQUAL STATIC_LIBRARY)
    target_link_libraries(${PROJECT_NAME} PRIVATE
        EtherLab::Qt6PdCom1plugin
    )
    target_compile_definitions(${PROJECT_NAME} PRIVATE STATIC_QTPDCOM)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>"
)

install(TARGETS ${PROJECT_NAME}
    ARCHIVE DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION       "${CMAKE_INSTALL_BINDIR}"
)

=== debian/changelog ===
qt6-qml-pdwidgets1 (1.0.1.g9354cb2-0+23.5) UNRELEASED; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Sun, 20 Jul 2025 05:41:41 +0000

qt6-qml-pdwidgets1 (1.0.1.g9354cb2-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100

=== debian/control ===
Source: qt6-qml-pdwidgets1
Priority: optional
Maintainer: Andreas Stewering-Bone <ab@igh.de>
Build-Depends: dh-exec (>= 0.3), debhelper (>= 9), qtchooser, qt6-base-dev, qt6-charts-dev, qt6-svg-dev, qt6-tools-dev, libqt6pdcom1-dev, cmake (>= 3.18), qt6-declarative-dev, qml6-module-qtpcom1-dev
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.etherlab.org

Package: libqt6-qml-pdwidgets1-dev
Section: libdevel
Architecture: any
Depends: libqt6-qml-pdwidgets1-1 (= ${binary:Version}), libqt6pdcom1-dev, ${misc:Depends}
Description: Process data widgets for QML
 This is a bundle of QML-based process data widgets for Qt6. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 Header files

Package: libqt6-qml-pdwidgets1-1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qml6-module-qtpcom1
Description: Process data widgets for QML
 This is a bundle of QML-based process data widgets for Qt6. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.

Package: pdserv-example-qmlviewer-qt6
Section: misc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt6-qml-pdwidgets1-1 (>= ${binary:Version}), qml6-module-qtquick-controls, qml6-module-qtquick-dialogs, qml6-module-qtquick-templates, qml6-module-qtquick-window, qml6-module-qtqml-workerscript, qml6-module-qtquick-layouts, qml6-module-qtqml, qml6-module-qtcharts
Suggests: libpdserv3-example
Description: Qml-based Gui for pdserv-example
 Gui which demonstrates how many of the QML-based process data widgets work.
 It is designed to interact with the oscillator demo provided by
 libpdserv3-example.
